#		By Ewa Marek, Sebastian Student
#    <CustomTools>
#      <Menu>
#       <Item name="Cell Track Plot Extension" icon="Python">
#         <Command>PythonXT::XTCellTrackPlotExtension()</Command>
#       </Item>
#      </Menu>
#    </CustomTools>
  
import ImarisLib
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
from collections import Counter
import Tkinter 
import tkFileDialog
import tkMessageBox
import tkFont

def XTCellTrackPlotExtension(aImarisId):
    
    vImarisLib = ImarisLib.ImarisLib()      
    Id = 0
    vImaris = vImarisLib.GetApplication(aImarisId) 
    
    
    class XTGUI(Tkinter.Tk):
        
        def __init__(self, master, aNames):       
            Tkinter.Tk.__init__(self, master)
            self.master = master
            self.grid()  
            self.configure(background='gray25')
    
            # title
            w = Tkinter.Label(self.master, text="XT Cell Track Plot Extension", fg='deeppink3', font='Times 38 bold', bg="gray25")
            w.grid(row=0, columnspan=2, padx=25, sticky=Tkinter.N)
    
    
            # exporting info
            lframe1 = Tkinter.LabelFrame(self, bd=4, relief=Tkinter.RIDGE, text="Export data to:", bg="gray25", fg="gray91", font="Times 20 bold" )
            lframe1.grid(row=0, column=2, rowspan=3, pady=75, padx=50, sticky=Tkinter.W)

            self.var1 = Tkinter.IntVar()
            self.option1 = Tkinter.Checkbutton(lframe1, text=".xlsx file", variable=self.var1, onvalue = 1, offvalue = 0, font='Times 18', bg="gray25", fg="gray91", selectcolor="black")
            self.option1.grid(row=1, column=0, padx=50, pady=10, sticky=Tkinter.W)
            self.var2 = Tkinter.IntVar()
            self.option2 = Tkinter.Checkbutton(lframe1, text=".csv file", variable=self.var2, onvalue = 1, offvalue = 0, font='Times 18', bg="gray25", fg="gray91", selectcolor="black")
            self.option2.grid(row=2, column=0, padx=50, pady=10, sticky=Tkinter.W)
            
            # exporting - directory
            lframe2 = Tkinter.LabelFrame(self, bd=4, relief=Tkinter.RIDGE, text="Please select the exported file location", bg="gray25", fg="gray91", font="Times 20 bold" )
            lframe2.grid(row=1, column=2, rowspan=4, pady=50, padx=50, sticky=Tkinter.W)
    
            self.ch_d = Tkinter.StringVar()
    
            self.w_exp = Tkinter.Button(lframe2, text='Directory', command = self.askdirectory, bg='gray10', fg="gray91") 
            self.w_exp.grid(row=6, column=0, padx=20, pady=20, sticky=Tkinter.W)
    
            self.chosen_directory = Tkinter.Label(lframe2, textvariable = self.ch_d, font='15', bg="gray25", fg="gray91")
            self.chosen_directory.grid(row=6, column=1, padx=20, pady=20,  sticky=Tkinter.E)
    
    
            # statistic
            self.lframe3 = Tkinter.LabelFrame(self, bd=4, relief=Tkinter.RIDGE, text="Statistic", bg="gray25", fg="gray91", font="Times 20 bold" )
            self.lframe3.grid(row=1, column=0, rowspan=4, pady=50, padx=50, sticky=Tkinter.W)        
            choosing = Tkinter.Label(self.lframe3, text="Choose a statistic to draw and export:", font='Times 20 bold', bg="gray25", fg="gray91")
            choosing.grid(row=0, column=0, columnspan=4, padx=30, pady=(40, 10), sticky=Tkinter.S)
            
            frame = Tkinter.Frame(self.lframe3, bd=2, relief=Tkinter.SUNKEN)
            frame.grid(row=1, rowspan=2, column=0,  padx=50, pady=(10, 30))
    
            self.statistic = Tkinter.StringVar()
    
            self.listbox = Tkinter.Listbox(frame, height=10,  cursor="hand2", font="Arial 15 italic", fg="black", selectmode=Tkinter.SINGLE, selectbackground="pink2", bg="gray67", exportselection=False)
            self.listbox.grid(row=0, column=0, columnspan=2, sticky=Tkinter.N)
    
            extra_font = tkFont.Font(choosing, choosing.cget("font"))
            extra_font.configure(underline=True)
            choosing.configure(font = extra_font)
    
            scrollbar = Tkinter.Scrollbar(frame)
            scrollbar.grid(row=0, column=5, sticky=Tkinter.NS)
            
            for item in aNames:
                self.listbox.insert(Tkinter.END, item)
          
            self.listbox.config(yscrollcommand=scrollbar.set, width=0) 
            scrollbar.config(command=self.listbox.yview)
            self.listbox.bind('<<ListboxSelect>>', self.get_canals)
    
            #channels
            choosing2 = Tkinter.Label(self.lframe3, text="Choose channels to draw and export:", font='Times 20 bold', bg="gray25", fg="gray91")
            choosing2.grid(row=3, column=0, columnspan=4, padx=30, pady=(30, 10), sticky=Tkinter.S)
            choosing2.configure(font = extra_font)
            
            self.listbox2 = Tkinter.Listbox(self.lframe3, height=6,  cursor="hand2", font="Arial 15 italic", fg="black", selectmode=Tkinter.MULTIPLE, selectbackground="pink2", bg="gray67", exportselection=False)
            self.listbox2.grid(row=5, column=0, columnspan=2, padx=50, pady=(10, 30), sticky=Tkinter.W)        
            
            #execute
            self.lets_do_it = Tkinter.Button(self, text='Execute', bg='gray10', font='Times 20', command=self.here_we_go, fg="gray91")#self.destroy)
            self.lets_do_it.grid(row=4, column=2, padx=50, pady=30, sticky=Tkinter.E)
    
            
    
        def askdirectory(self):
            dirname = tkFileDialog.askdirectory()
            if dirname:
                self.ch_d.set(dirname) 
    
        def files_type(self):
            
            self.is_xlsx = self.var1.get()
            self.is_csv = self.var2.get()
            self.saving_path = self.ch_d.get()
                   
            return self.is_xlsx, self.is_csv, self.saving_path
           
        def get_canals(self, e):
           
           self.statistic = self.listbox.get(self.listbox.curselection())
           self.to_table, self.uniq_canals, self.x_size, self.no_canals = make_to_table(mIds, aNames, mValues, mFactors, generations, uniq_id_path, self.statistic, data_track_id)
           self.listbox2.delete(0, Tkinter.END)
           
           for can in self.uniq_canals:
               
               if self.no_canals == 1:
                   
                   self.listbox2.insert(Tkinter.END, "No channels for this statistic")
               else:
                   
                   self.listbox2.insert(Tkinter.END, "Channel " + str(can))
            
               self.listbox2.config(width=30)
               
        def here_we_go(self):
            self.users_c = map(int, self.listbox2.curselection())
            self.users_canals = [[]]*len(self.users_c)               
            self.remember = 0        
            
            for i in range(len(self.users_c)):        
            
                self.users_canals[i] = self.uniq_canals[self.users_c[i]]
                self.remember = 0
                
            if not self.users_canals and self.no_canals == 1:
                self.users_canals = self.uniq_canals
            if not self.users_canals and self.no_canals != 1:
                tkMessageBox.showwarning("Warning!", "No channels chosen!")
                self.remember = 1
            if self.remember != 1:    
                self.destroy()
       
    ###############################################################################
    
    def find_ids(data, gener, path_id, data2):
        
        cell_ids = []  
        
        if type(gener) == float:
        
            for i in range(len(data[1])):
                        
                    if path_id == data[1][i] and gener == data[2][i]:
                            
                        cell_ids.append(data[0][i])      
            branches = 0            
        
        else:    
        
            for i in range(len(data[1])):
                for j in range(len(gener)):
                        
                    if path_id == data[1][i] and gener[j] == data[2][i]:
                        
                       
                        cell_ids.append(data[0][i])
    
            a = data2[np.where(data2[:, 1] == 'Cell Track Number of Branches')]
            b = a[np.where(a[:, 0] == str(int(path_id))), 2]
            b= b.astype(float) 
            branches = b[0]
    
        return cell_ids, branches
        
     #############################################################################   
    def find_edges(aTE, from_find_ids, branches):    
    
        if type(branches) == int or len(branches) == 0:
    
            Edges = [-1]*len(from_find_ids)
            k=0    
            
            for i in from_find_ids:      
                for j in range(len(aTE[0])):
                    if i == aTE[0][j]:
                        Edges[k] = aTE[1][j]
                k = k+1                  
                        
            edges = [from_find_ids, Edges]
            cnt = Counter(from_find_ids)
            cell_div = [ktore for ktore, v in cnt.iteritems() if v > 1] 
            
        else:    
            Edges = [-1]*(len(from_find_ids) + int(branches[0]))
    
            from_fi = [0]*len(Edges)
            k=0    
            
            for i in from_find_ids:
                
                t = 0        
                
                for j in range(len(aTE[0])):
                    if i == aTE[0][j]:
                        Edges[k] = aTE[1][j]
                        from_fi[k] = i            
                        k = k+1    
                        t = 1
                    else:               
                        from_fi[k] = i     
                        
                if t != 1:        
                    k = k+1                
                        
            edges = [from_fi, Edges]   
            cnt = Counter(from_fi)
            cell_div = [ktore for ktore, v in cnt.iteritems() if v > 1] 
        
        return edges, cell_div    
        
     ############################################################################   
    def cell_tracks(f_edges, generations):
    
        # znalezieni poczatku sciezek, czyli '-1'
        start = [i for i, j in enumerate(f_edges[1]) if j == -1]
        sciezka = [[] for _ in range(len(start))]
    
        for i in range(len(start)):
        
            w2 = [0]
            w1 = f_edges[0][start[i]]
            sciezka[i].append(w1)    
        
            while len(w2) != 0:
                          
                          w2 = [p for p, r in enumerate(f_edges[1]) if r == w1]
                          
                          if len(w2) != 0:        
    
                                ind = w2[0]
                                w1 = f_edges[0][ind]
                                sciezka[i].append(w1)
    
    
        for i in range(len(start)):
            for j in range(len(sciezka[i])):
                id_z_sciezki = generations[0].index(sciezka[i][j])
                z = 1 + i
                generations[3][id_z_sciezki] = generations[3][id_z_sciezki] + [z]   
    
        data_with_cell_track = generations
        how_many_cells = len(sciezka)
    
        return data_with_cell_track, how_many_cells  
    ############################################################################
    
    def make_to_table(mIds, aNames, mValues, mFactors, generations, uniq_id_path, statistic, data_track_id): 
        
        to_table = np.column_stack((mIds, aNames, mValues, mFactors[1], mFactors[3]))
        to_table = to_table[np.where(to_table[:, 1] == statistic)]
        to_table = np.transpose(to_table)
        to_table = to_table.tolist() 
        to_table[0] = map(int, to_table[0])
        to_table[2] = map(float, to_table[2])
        try:
            to_table[3] = map(int, to_table[3])
            no_canals = 0
        except ValueError:
            to_table[3] = to_table[3]
            no_canals = 1
        try:    
            to_table[4] = map(int, to_table[4])
        except ValueError:
            to_table[4] = to_table[4]
            
        x_size = len(np.unique(to_table[4]))+1
        id_track = []
        id_cell_track = []
        
        for i in range(len(to_table[0])):
            
            ind = generations[0].index(to_table[0][i])
            id_track.append(generations[1][ind])
            id_cell_track.append(generations[3][ind])
                
        to_table.append(id_track)
        to_table.append(id_cell_track)
        
        to_table.append([[]]*len(id_track))
        to_table.append([[]]*len(id_track))  
          
        for i in range(len(uniq_id_path)):
            
            traki = [p for p, r in enumerate(to_table[5]) if r == uniq_id_path[i]]
            
            for j in traki:
                to_table[7][j] = data_track_id[1][i]
                to_table[8][j] = data_track_id[2][i]
        
        uniq_canals = list(set(to_table[3])) 
        
        return to_table, uniq_canals, x_size, no_canals    
     
    ##############################################################################
    
       

    
    if vImaris is None:
        tkMessageBox.showerror("Error!", "Could not connect to Imaris!")
        
    vScene = vImaris.GetSurpassScene()
    factory = vImaris.GetFactory()
    vSelection = vImaris.GetSurpassSelection()
    
    # do komorek
    vCells = factory.ToCells(vSelection)
    vIds = vCells.GetIds()  # id komorek == aNumOfCell
    aIndicesT = vCells.GetIndicesT()	# indeksy czasu komorek = aNumOfCell
    aTrackEdges = vCells.GetTrackEdges() # < aNumOfCell
    aTrackIds = vCells.GetTrackIds()	#  == aTrackEdges    
        
    ate = np.array(aTrackEdges)
    ate = np.transpose(ate)
    aTE = ate.tolist() # wynik to: aTE[0] - od, aTE[1] - do
    aTI = aTrackIds
    
    r1 = np.column_stack((aTI,aTE[0]))
    r2 = np.column_stack((aTI,aTE[1])) 
    razem = np.concatenate((r1, r2), axis = 0)
    razem_posort = razem[razem[:, 1].argsort()]
    razem_posort = np.transpose(razem_posort)
    razem_posort = razem_posort.tolist()
    razem_posort[0] = map(float, razem_posort[0])
    razem_posort[1] = map(int, razem_posort[1])
    
    aStat = vCells.GetStatistics()
    mFactorNames = aStat.mFactorNames
    mFactors = aStat.mFactors
    mIds = aStat.mIds
    aNames = aStat.mNames
    aUnits = aStat.mUnits
    mValues = aStat.mValues
    
    data = np.column_stack((mIds, aNames, mValues)) 
    generations = data[np.where(data[:, 1] == 'Cell Generation')] # kom. indeksowane od 0 do 322
    TrId = np.zeros(len(generations[:, 0]))
    generations[:, 1] = TrId[:]
    generations = np.transpose(generations)
    generations = generations.tolist()  # c0 -> cell id, c1 -> cell's track id, c2 -> cell's generation
    generations[0] = map(int, generations[0])
    generations[1] = map(float, generations[1])
    generations[2] = map(float, generations[2])
    
    for i in range(len(generations[0])):
        for j in range(len(razem_posort[0])):        
            if generations[0][i] == razem_posort[1][j]:
                generations[1][i] = razem_posort[0][j]
    
    generations.append([[]]*len(generations[0]))
          
    
    uniq_id_path = list(set(generations[1]))
    try:    
        bad_id = uniq_id_path.index(0.0)
        del uniq_id_path[bad_id]
    except:
        pass
    uniq_gener = list(set(generations[2]))    
    
    cell_div = [[]]*len(uniq_id_path)
    hmc = [[]]*len(uniq_id_path)
    
    for i in range(len(uniq_id_path)):
        f_id, branches = find_ids(generations, uniq_gener, uniq_id_path[i], data)
        f_edges, cell_div[i] = find_edges(aTE, f_id, branches)    
        new_data, hmc[i] = cell_tracks(f_edges, generations)
    
    # track_id, indeksy dzielacych sie komorek, ilosc sciezek w danym track_id    
    data_track_id = [uniq_id_path, cell_div, hmc]    
    y_size = np.sum(data_track_id[2])+1
    
    
    ## TU MA POJAWIC SIE OKNO
    graf = XTGUI(None, np.unique(aNames))
    graf.title("XT Cell Track Id Extension") 
    #graf.withdraw()
    #graf.wait_window()
                              
    graf.mainloop()
    
    time = np.unique(graf.to_table[4])
    time = np.array(sorted(time))
    dataset = np.empty((y_size, graf.x_size)) 
    dataset.fill(np.nan)
    dataset[0, 1:] = time
    wiersz = 0
    wh_track_id = [[]]*(y_size-1)
    for t in range(len(data_track_id[0])):
        for i in range(data_track_id[2][t]):
            
            dataset[wiersz+1, 0] = i+1
            wh_track_id[wiersz] = data_track_id[0][t]
            wiersz = wiersz+1
            
    values = np.copy(dataset)
    markers = np.copy(dataset)
    divisions = sum(data_track_id[1], [])
    
    if graf.var1.get() == 1:
        writer = pd.ExcelWriter(str(graf.ch_d.get()) + '/' + graf.statistic +'.xlsx')
    
    
    
    for c in range(len(graf.users_canals)):  
        
        try:    
            channel = int(graf.users_canals[c])
            
            if graf.no_canals == 0:
                    wanted_channel = [p for p,r in enumerate(graf.to_table[3]) if r == channel]
                    
        except ValueError:    
            wanted_channel = [p for p,r in enumerate(graf.to_table[3]) if r == graf.users_canals[0]]
         
        track = [[]]*y_size
        track[0] = np.nan
     
    
        for i in range(y_size-1):       
            for j in range(graf.x_size-1):
                
                e = wanted_channel
                f = [p for p,r in enumerate(graf.to_table[5]) if r == wh_track_id[i]]  # gdzie track_id rowny zadanemu
                g = [p for p,r in enumerate(graf.to_table[4]) if r == dataset[0, j+1]] # gdzie czas rowny temu w kolumnie
                h = [p for p,r in enumerate(graf.to_table[6]) if dataset[i+1, 0] in r] 
                                             # gdzie cell_track_id rowny temu w wierszu
                inde = list(set(h) & set(g) & set(f) & set(e))
                if len(inde) != 0:
                    
                    track[i+1] = graf.to_table[5][inde[0]]
                    dataset[i+1, j+1] = graf.to_table[0][inde[0]] # tablica z id komorek
                    values[i+1, j+1] = graf.to_table[2][inde[0]]
                    
                    if graf.to_table[0][inde[0]] in divisions:
                        markers[i+1, j+1] = graf.to_table[2][inde[0]]
       
        col = ['b-', 'g-', 'c-', 'k-']
        plt.figure()
 
        z = 0          
          
        for i in range(y_size-1):
            maska = ~np.isnan(values[i+1,:])
            maska[0] = False  
            
            plt.plot(values[0, maska], values[i+1, maska], col[z])
            z = z+1
            if z == 4:
                z =  0
            #plt.plot(markers[0, maska], values[i+1, maska], 'r^') wyswietla wszystkie wartosci jako punkty
            plt.plot(markers[0, 1:], markers[i+1, 1:], 'ro')
            
        
        
        plt.grid()
        plt.xlabel('Time')
        plt.ylabel(graf.statistic)
        
        if graf.no_canals == 1:
            plt.title(graf.statistic)
        else:
            plt.title(graf.statistic +' (Channel = ' + str(graf.users_canals[c]) + ')')
            
        plt.show()
        
        track = map(str, track)
        track[0] = 'Track Id'
        
        time2 = time.astype(str)
        time2 = time2.tolist()
        time2 = ['Ext. Cell Id \ Time'] + time2
        nice_table = pd.DataFrame(values, index = track, columns = time2)  
    
     
    
        if graf.var1.get()==1:
            if graf.no_canals == 1:
                nice_table.to_excel(writer, graf.statistic)
            else:
                
                nice_table.to_excel(writer, graf.statistic +' (Ch=' + str(graf.users_canals[c]) + ')')
    
        if graf.var2.get()==1:
            
            if graf.no_canals == 1:
                nice_table.to_csv(str(graf.ch_d.get()) + '/' + graf.statistic + '.csv')
            else:
                nice_table.to_csv(str(graf.ch_d.get()) + '/' + graf.statistic +' (Channel = ' + str(graf.users_canals[c]) + ')'+'.csv')

    if graf.var1.get() == 1:      
        writer.save()            
             
                
                